## gpsd 3.15

=== SConstruct ===
## SCons build recipe for the GPSD project

# Important targets:
#
# build      - build the software (default)
# dist       - make distribution tarball
# install    - install programs, libraries, and manual pages
# uninstall  - undo an install
#
# check      - run regression and unit tests.
# audit      - run code-auditing tools
# testbuild  - test-build the code from a tarball
# website    - refresh the website
# release    - ship a release
#
# --clean    - clean all normal build targets
# sconsclean - clean up scons dotfiles (but not the database)
#
# Setting the DESTDIR environment variable will prefix the install destinations
# without changing the --prefix prefix.

# Unfinished items:
# * Out-of-directory builds: see http://www.scons.org/wiki/UsingBuildDir
# * Coveraging mode: gcc "-coverage" flag requires a hack for building the python bindings

# Release identification begins here
gpsd_version = "3.15"

# client library version
libgps_version_current   = 22
libgps_version_revision  = 0
libgps_version_age       = 0

# Release identification ends here

# Hosting information (mainly used for templating web pages) begins here
# Each variable foo has a corresponding @FOO@ expanded in .in files.
# There are no project-dependent URLs or references to the hosting site
# anywhere else in the distribution; preserve this property!
sitename   = "Savannah"
sitesearch = "catb.org"
website    = "http://catb.org/gpsd"
mainpage   = "https://savannah.nongnu.org/projects/gpsd/"
webupload  = "login.ibiblio.org:/public/html/catb/gpsd"
cgiupload  = "thyrsus.com:/home/www/thyrsus.com/cgi-bin/"
scpupload  = "dl.sv.nongnu.org:/releases/gpsd/"
mailman    = "https://lists.nongnu.org/mailman/listinfo/"
admin      = "https://savannah.nongnu.org/project/admin/?group=gpsd"
download   = "http://download-mirror.savannah.gnu.org/releases/gpsd/"
bugtracker = "https://savannah.nongnu.org/bugs/?group=gpsd"
browserepo = "http://git.savannah.gnu.org/cgit/gpsd.git"
clonerepo  = "https://savannah.nongnu.org/git/?group=gpsd"
gitrepo    = "git://git.savannah.nongnu.org/gpsd.git"
webform    = "http://www.thyrsus.com/cgi-bin/gps_report.cgi"
formserver = "www@thyrsus.com"
devmail    = "gpsd-dev@lists.nongnu.org"
usermail   = "gpsd-users@lists.nongnu.org"
annmail    = "gpsd-announce@nongnu.org"
ircchan    = "irc://chat.freenode.net/#gpsd"
tiplink    = "<a href='http://gratipay.com/esr'>leave a tip at Gratipay</a>"
tipwidget  = "<script data-gratipay-username='esr' \
	data-gratipay-widget='button' src='//gttp.co/v1.js'></script>"
# Hosting information ends here

EnsureSConsVersion(2,3,0)

import copy, os, sys, glob, re, platform, time
from distutils import sysconfig
from distutils.util import get_platform
import SCons

# replacement for functions from the commands module, which is deprecated.
from subprocess import PIPE, STDOUT, Popen
def _getstatusoutput(cmd, input=None, cwd=None, env=None):
    pipe = Popen(cmd, shell=True, cwd=cwd, env=env, stdout=PIPE, stderr=STDOUT)
    (output, errout) = pipe.communicate(input=input)
    status = pipe.returncode
    return (status, output)
def _getoutput(cmd, input=None, cwd=None, env=None):
    return _getstatusoutput(cmd, input, cwd, env)[1]


#
# Build-control options
#

# Start by reading configuration variables from the cache
opts = Variables('.scons-option-cache')

systemd_dir = '/lib/systemd/system'
systemd = os.path.exists(systemd_dir)

# Set distribution-specific defaults here
imloads = True

boolopts = (
    # GPS protocols
    ("nmea0183",      True,  "NMEA0183 support"),
    ("ashtech",       True,  "Ashtech support"),
    ("earthmate",     True,  "DeLorme EarthMate Zodiac support"),
    ("evermore",      True,  "EverMore binary support"),
    ("fv18",          True,  "San Jose Navigation FV-18 support"),
    ("garmin",        True,  "Garmin kernel driver support"),
    ("garmintxt",     True,  "Garmin Simple Text support"),
    ("geostar",       True,  "Geostar Protocol support"),
    ("itrax",         True,  "iTrax hardware support"),
    ("mtk3301",       True,  "MTK-3301 support"),
    ("navcom",        True,  "Navcom NCT support"),
    ("oncore",        True,  "Motorola OnCore chipset support"),
    ("sirf",          True,  "SiRF chipset support"),
    ("superstar2",    True,  "Novatel SuperStarII chipset support"),
    ("tnt",           True,  "True North Technologies support"),
    ("tripmate",      True,  "DeLorme TripMate support"),
    ("tsip",          True,  "Trimble TSIP support"),
    ("ublox",         True,  "u-blox Protocol support"),
    ("fury",          True,  "Jackson Labs Fury and Firefly support"),
    ("nmea2000",      True,  "NMEA2000/CAN support"),
    # Non-GPS protocols
    ("aivdm",         True,  "AIVDM support"),
    ("gpsclock",      True,  "GPSClock support"),
    ("ntrip",         True,  "NTRIP support"),
    ("oceanserver",   True,  "OceanServer support"),
    ("rtcm104v2",     True,  "rtcm104v2 support"),
    ("rtcm104v3",     True,  "rtcm104v3 support"),
    ("passthrough",   True,  "build support for passing through JSON"),
    # Time service
    ("ntp",           True,  "NTP time hinting support"),
    ("ntpshm",        True,  "NTP time hinting via shared memory"),
    ("pps",           True,  "PPS time syncing support"),
    # Export methods
    ("socket_export", True,  "data export over sockets"),
    ("dbus_export",   True,  "enable DBUS export support"),
    ("shm_export",    True,  "export via shared memory"),
    # Communication
    ('usb',           True,  "libusb support for USB devices"),
    ("bluez",         True,  "BlueZ support for Bluetooth devices"),
    ("ipv6",          True,  "build IPv6 support"),
    ("netfeed",       True,  "build support for handling TCP/IP data sources"),
    # Other daemon options
    ("force_global",  False, "force daemon to listen on all addressses"),
    ("timing",        False, "latency timing support"),
    ("control_socket",True,  "control socket for hotplug notifications"),
    ("systemd",       systemd, "systemd socket activation"),
    # Client-side options
    ("clientdebug",   True,  "client debugging support"),
    ("ncurses",       True,  "build with ncurses"),
    ("libgpsmm",      True,  "build C++ bindings"),
    ("qt",            True,  "build QT bindings"),
    # Daemon options
    ("reconfigure",   True,  "allow gpsd to change device settings"),
    ("controlsend",   True,  "allow gpsctl/gpsmon to change device settings"),
    ("nofloats",      False, "float ops are expensive, suppress error estimates"),
    ("squelch",       False, "squelch gpsd_log/gpsd_hexdump to save cpu"),
    # Build control
    ("shared",        True,  "build shared libraries, not static"),
    ("implicit_link", imloads,"implicit linkage is supported in shared libs"),
    ("python",        True,  "build Python support and modules."),
    ("debug",         False, "include debug information in build"),
    ("profiling",     False, "build with profiling enabled"),
    ("coveraging",    False, "build with code coveraging enabled"),
    ("nostrip",       False, "don't symbol-strip binaries at link time"),
    ("manbuild",      True,  "build help in man and HTML formats"),
    ("leapfetch",     True,  "fetch up-to-date data on leap seconds."),
    ("minimal",       False, "turn off every option not set on the command line"),
    # Test control
    ("slow",          False, "run tests with realistic (slow) delays"),
    )
for (name, default, help) in boolopts:
    opts.Add(BoolVariable(name, help, default))

# Gentoo, Fedora, opensuse systems use uucp for ttyS* and ttyUSB*
if os.path.exists("/etc/gentoo-release"):
   def_group = "uucp"
else:
   def_group = "dialout"

nonboolopts = (
    ("gpsd_user",           "nobody",      "privilege revocation user",),
    ("gpsd_group",          def_group,     "privilege revocation group"),
    ("prefix",              "/usr/local",  "installation directory prefix"),
    ("python_libdir",       sysconfig.get_python_lib(plat_specific=1),
                                           "Python module directory prefix"),
    ("max_clients",         '64',          "maximum allowed clients"),
    ("max_devices",         '4',           "maximum allowed devices"),
    ("fixed_port_speed",    0,             "fixed serial port speed"),
    ("fixed_stop_bits",     0,             "fixed serial port stop bits"),
    ("target",              "",            "cross-development target"),
    ("sysroot",             "",            "cross-development system root"),
    )
for (name, default, help) in nonboolopts:
    opts.Add(name, help, default)

pathopts = (
    ("sysconfdir",          "etc",           "system configuration directory"),
    ("bindir",              "bin",           "application binaries directory"),
    ("includedir",          "include",       "header file directory"),
    ("libdir",              "lib",           "system libraries"),
    ("sbindir",             "sbin",          "system binaries directory"),
    ("mandir",              "share/man",     "manual pages directory"),
    ("docdir",              "share/doc",     "documents directory"),
    ("udevdir",             "/lib/udev",     "udev rules directory"),
    ("pkgconfig",           "$libdir/pkgconfig", "pkgconfig file directory"),
    )
for (name, default, help) in pathopts:
    opts.Add(PathVariable(name, help, default, PathVariable.PathAccept))

#
# Environment creation
#
import_env = (
    "MACOSX_DEPLOYMENT_TARGET", # Required by MacOSX 10.4 (and probably earlier)
    "DISPLAY",         # Required for dia to run under scons
    "GROUPS",          # Required by gpg
    "HOME",            # Required by gpg
    "LOGNAME",         # LOGNAME is required for the flocktest production.
    'PATH',            # Required for ccache and Coverity scan-build
    'PKG_CONFIG_PATH', # Set .pc file directory in a crossbuild
    'PKG_CONFIG_SYSROOT_DIR', # Pass more environment variables to pkg-config (required for crossbuilds)
    'PKG_CONFIG_LIBDIR',      # Pass more environment variables to pkg-config (required for crossbuilds)
    'STAGING_DIR',     # Required by the OpenWRT and CeroWrt builds.
    'STAGING_PREFIX',  # Required by the OpenWRT and CeroWrt builds.
    'WRITE_PAD',       # So we can test WRITE_PAD values on the fly.
    )
envs = {}
for var in import_env:
    if var in os.environ:
        envs[var] = os.environ[var]
envs["GPSD_HOME"] = os.getcwd()

env = Environment(tools=["default", "tar", "textfile"], options=opts, ENV=envs)
opts.Save('.scons-option-cache', env)
env.SConsignFile(".sconsign.dblite")

#  Minimal build turns off every option not set on the command line,
if env['minimal']:
    for (name, default, help) in boolopts:
        if default == True and not ARGUMENTS.get(name):
            env[name] = False

# NTPSHM requires NTP
if env['ntpshm']:
    env['ntp'] = True

for (name, default, help) in pathopts:
    env[name] = env.subst(env[name])

env['VERSION'] = gpsd_version
env['PYTHON'] = sys.executable

# Set defaults from environment.  Note that scons doesn't cope well
# with multi-word CPPFLAGS/LDFLAGS/SHLINKFLAGS values; you'll have to
# explicitly quote them or (better yet) use the "=" form of GNU option
# settings.
env['STRIP'] = "strip"
env['PKG_CONFIG'] = "pkg-config"
for i in ["AR", "ARFLAGS", "CCFLAGS", "CFLAGS", "CC", "CXX", "CXXFLAGS", "LINKFLAGS", "STRIP", "PKG_CONFIG", "LD", "TAR"]:
    if os.environ.has_key(i):
        j = i
        if i == "LD":
            i = "SHLINK"
        if i in ("CFLAGS", "CCFLAGS", "LINKFLAGS"):
            env.Replace(**{j: Split(os.getenv(i))})
        else:
            env.Replace(**{j: os.getenv(i)})
for flag in ["LDFLAGS", "SHLINKFLAGS", "CPPFLAGS"]:
    if os.environ.has_key(flag):
        env.MergeFlags({flag : [os.getenv(flag)]})


# Keep scan-build options in the environment
for key, value in os.environ.iteritems():
    if key.startswith('CCC_'):
        env.Append(ENV={key:value})

=== contrib/SConstruct ===
# This is a skeleton recipe to simplify building some of these little
# utilities. They probably won't be useful to many users, and they probably
# won't get used on a daily basis, but someone might find them useful for
# tinkering with their gear.

ashctl = Program("ashctl", ["ashctl.c", "../strl.c"])
binlog = Program("binlog", "binlog.c")
binreplay = Program("binreplay", "binreplay.c", parse_flags=['-lutil'])
lla2ecef = Program("lla2ecef", "lla2ecef.c", parse_flags=['-lm'])
motosend = Program("motosend", ["motosend.c", "../strl.c"])
ppscheck = Program("ppscheck", "ppscheck.c")

Default(ashctl, binlog, binreplay, lla2ecef, motosend, ppscheck)

=== debian/changelog ===
gpsd (3.15-2build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 06 Feb 2016 20:52:52 +0000

gpsd (3.15-2) unstable; urgency=medium

  * Uploading to unstable

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 31 Oct 2015 20:02:31 +0100

gpsd (3.15-1) experimental; urgency=medium

  * [10e7caf] Install contrib/* as examples.
    Thanks to Sanjeev Gupta (Closes: #781688)
  * [2d150e4] Merge tag 'upstream/3.15'
    Upstream version 3.15
  * [4163f08] snapshot changelog.
  * [1ea8da4] Remove libgpsd.
    Upstream links it statically now and I can't be bothered to maintain
    patches as Gentoo and others do it.
    The result is a slightly larger gpsd-clients package and running
    the binaries in parallel will waste memory.
    Thanks to Paul Wise & Andreas Beckmann (Closes: #779286, #781567)
  * [bb7a556] scons distclean doesn't work anymore.
    use --clean + sconsclean.
  * [31ff968] Refreshing patches
  * [5861e60] Fix broken static linking of test_gpsmm
  * [ef84468] Install new files.
  * [f9e250c] Add patch to fix regression tests for leap second bump
  * [65b8ac6] Updating symbols file.
  * [7e3d4a4] Update libqgpsmm symbols.
  * [785e932] _STRUCT_TIMESPEC is not defined in time.h anymore.
    Only linux/time.h defines _STRUCT_TIMESPEC.
    Check for __timespec_defined additionally.
  * [0b56700] Fix struct member names in timspec.
  * [e723fdd] Use system clock_gettime again.
    Fix some more broken header checks in SConstruct.

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 31 Oct 2015 20:02:07 +0100

gpsd (3.12-1) experimental; urgency=medium

  * [9f0dfbda] Merge tag 'upstream/3.12'
    Upstream version 3.12
  * [0896c861] Refresh/update patches.
  * [9daccea4] Fix test_ debug tool list.
  * [85f4f0bb] Add patch to fix test_gpsmm.
  * [9c511016] Add some new symbols to the symbols file.
  * [30cf1b92] Add dh-python as build dependency.
  * [24c325f9] Bump library sonames in package names.
  * [a810ac32] Update libqgpsmm symbols file
  * [1bf373c6] Fix some lintian errors.

 -- Bernd Zeimetz <bzed@debian.org>  Mon, 23 Feb 2015 22:37:42 +0100

=== debian/control ===
Source: gpsd
Section: misc
Priority: optional
Maintainer: Bernd Zeimetz <bzed@debian.org>
Build-Depends: debhelper (>= 8.1.3~),
 python-all-dev (>= 2.6.6-3),
 python-all-dbg (>= 2.6.6-3),
 xsltproc, docbook-xsl, docbook-xml,
 libncurses-dev,
 libusb-1.0-0-dev [!hurd-any],
 libdbus-1-dev, libglib2.0-dev, libdbus-glib-1-dev, makedev,
 libbluetooth-dev [linux-any],
 libqt4-dev,
 lsb-release, bc,
 dpkg-dev (>= 1.15.6),
 scons (>= 2.0.1), chrpath,
 dh-buildinfo,
 pps-tools (>= 0.20120406+g0deb9c7e-2~) [linux-any],
 dh-systemd (>= 1.3),
 dh-python
Standards-Version: 3.9.2
Homepage: http://www.catb.org/gpsd/
Vcs-Browser: http://git.recluse.de/?p=debian/pkg-gpsd.git
Vcs-Git: git://git.recluse.de/debian/pkg-gpsd.git
X-Python-Version: >= 2.3

Package: gpsd
Architecture: any
Depends: netbase | systemd-sysv, lsb-base (>= 3.2-13),
 adduser (>= 3.34),
 ${shlibs:Depends}, ${misc:Depends},
 libgps22 (= ${binary:Version})
Recommends: udev [linux-any], ${python:Depends}, python
Breaks: ${gpsd:Breaks}
Suggests: gpsd-clients, dbus
Conflicts: fso-gpsd
Multi-Arch: foreign
Description: Global Positioning System - daemon
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 With gpsd, multiple GPS client applications can share access to devices
 without contention or loss of data. Also, gpsd responds to queries with a
 format that is substantially easier to parse than the different standards
 emitted by GPS devices.

Package: gpsd-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
 libgps22 (= ${binary:Version}) | gpsd (= ${binary:Version}) | gpsd-clients (= ${binary:Version}) | python-gps (= ${binary:Version})
Description: Global Positioning System - debugging symbols
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains the detached debug symbols for gpsd, gpsd-clients,
 python-gps, and libgps22.

Package: gpsd-clients
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libgps22 (= ${binary:Version}),
 python-gps, python-gtk2, python-cairo, ${python:Depends}, python
Suggests: gpsd
Conflicts: gps
Breaks: ${python:Breaks}
Description: Global Positioning System - clients
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains auxiliary tools and example clients for monitoring and
 testing gpsd.

Package: python-gps
Architecture: any
Section: python
Replaces: gpsd-clients (<< 2.34.dfsg-1)
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
 python (>= 2.6) | python-simplejson
Recommends: gpsd
Provides: ${python:Provides}
Breaks: ${python:Breaks}
Conflicts: python-json
Description: Global Positioning System - Python libraries
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains a Python interface to connect to gpsd, together with
 a module providing a controlled testing environment. It also ships two tools
 which utilize the interface: gpsprof for latency-profiling, and gpsfake to
 simulate a GPS by playing back a logfile.

Package: libgps22
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gpsd
Conflicts: fso-gpsd
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Global Positioning System - library
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides libgps, a C service library for querying GPS
 devices. It supports both a low-level interface, which communicates
 directly with the device to which the GPS is connected, and a high-level
 interface, which goes through gpsd and is intended for concurrent use by
 several applications.

Package: libgps-dev
Architecture: any
Section: libdevel
Depends: libgps22 (= ${binary:Version}), ${misc:Depends}, pkg-config
Breaks: gpsd (<< 2.34.dfsg-1)
Replaces: gpsd (<< 2.34.dfsg-1)
Description: Global Positioning System - development files
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains the header and development files needed to build
 programs and packages using libgps.

Package: libqgpsmm22
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Global Positioning System - Qt wrapper for libgps
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides libQgpsmm, the Qt version of libgpsmm.
 It is a wrapper over libgps, the service library for querying GPS
 devices. libQgpsmm is available on all platforms which are supported
 by Qt4.

Package: libqgpsmm-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, pkg-config,
 libqgpsmm22 (= ${binary:Version}),
 libgps-dev (= ${binary:Version})
Description: Global Positioning System - Qt wrapper for libgps (development)
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides libQgpsmm, the Qt version of libgpsmm.
 It is a wrapper over libgps, the service library for querying GPS
 devices. libQgpsmm is available on all platforms which are supported
 by Qt4.

=== debian/rules ===
#!/usr/bin/make -f

#uncomment if debhelper should be verbose
#export DH_VERBOSE=1

DEBIAN_VERSION := $(strip $(shell dpkg-parsechangelog| awk '/Version/{print $$2}'))

LIBGPS_SONAME := $(strip $(shell grep -E '^libgps_version_current' SConstruct | sed 's,.*=[^0-9]*\([0-9]*\).*,\1,'))


LIBGPS_DEBIAN_FILE_SOURCES := $(strip $(shell ls -1 debian/*LIBGPSSONAME* ))
LIBGPS_DEBIAN_FILE_TARGETS := $(strip $(shell echo $(LIBGPS_DEBIAN_FILE_SOURCES) | sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g'))

#python versions
PYTHONS := $(shell pyversions -vr)
PYTHON_DEFAULT := $(strip $(shell pyversions -vd))

#debhelper version and settings needed for udev
DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')
LSB_RELEASE := $(shell lsb_release -si)
UDEV_BREAKS =

ifeq (Debian,$(strip $(LSB_RELEASE))) ## debian ##
ifeq (0, $(strip $(shell dpkg --compare-versions $(DH_VERSION) ge 7.3.15; echo $$?)))
UDEV_BREAKS = 125
endif
else ## not debian ##
ifeq (Ubuntu,$(strip $(LSB_RELEASE))) ## ubuntu ##
ifeq (0, $(strip $(shell dpkg --compare-versions $(DH_VERSION) ge 7.0.17ubuntu2; echo $$?)))
UDEV_BREAKS = 136-1
endif
endif ## ubuntu ##
endif ## debian ##


DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

SCONSOPTS = \
	prefix=/usr \
	systemd=yes \
	strip=no \
	dbus_export=yes \
	docdir=/usr/share/doc/gpsd \
	libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	gpsd_user=gpsd \
	gpsd_group=dialout


ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	SCONSOPTS += debug=yes
else
	SCONSOPTS += debug=no
endif

SCONSSTATICOPTS = python=no shared=no


#package names
PACKAGE_GPSD := gpsd
PACKAGE_CLIENTS := gpsd-clients
PACKAGE_LIB := libgps$(LIB_soname)
PACKAGE_QTLIB := libqgpsmm$(LIB_soname)
PACKAGE_LIB_DEV := libgps-dev
PACKAGE_QTLIB_DEV := libqgpsmm-dev
PACKAGE_PY := python-gps
PACKAGE_GPSDDBG := gpsd-dbg


cflags := $(shell dpkg-buildflags --get CFLAGS)
cppflags := $(shell dpkg-buildflags --get CPPFLAGS)
cxxflags := $(shell dpkg-buildflags --get CXXFLAGS)
ldflags := $(shell dpkg-buildflags --get LDFLAGS)

SCONS_ENV := set -e ;\
		export LDFLAGS="$(ldflags)" ;\
		export CFLAGS="$(cflags)" ;\
		export CXXFLAGS="$(cxxflags)" ;\
		export CPPFLAGS="$(cppflags)";


$(LIBGPS_DEBIAN_FILE_TARGETS): $(LIBGPS_DEBIAN_FILE_SOURCES)
	for source in $(LIBGPS_DEBIAN_FILE_SOURCES); do \
	    target=$$(echo "$$source" | sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g') ;\
	    sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g' "$$source" > "$$target" ;\
	done

debian/control: debian/control.in
	if grep -q "Package: libgps$(LIBGPS_SONAME)" debian/control; then \
		touch debian/control ;\
	else \
		rm -f $@ ;\
		sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g' $< > $@ ;\
		if [ -d .git ]; then \
			git add debian/control ;\
			git commit -m 'Updating debian/control from debian/control.in' debian/control ;\
		fi ;\
	fi

SConstruct.deb_revision: SConstruct
	if [ ! -f $@ ]; then \
		cp $< $@ ;\
		sed -i '/^revision=/s/%(.*)/%("$(DEBIAN_VERSION)",)/' $< ;\
	fi
	touch $@

build-indep: build
build-arch: build

build: build-stamp build-static-stamp
build-stamp: SConstruct.deb_revision
	set -e; \
	    for py in $(PYTHONS); do \
	    	$(SCONS_ENV) python$${py} /usr/bin/scons $(SCONSOPTS); \
		$(SCONS_ENV) python$${py}-dbg /usr/bin/scons $(SCONSOPTS); \
	    done
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# disable tests on hurd due to weird ipv6 errors
	# http://deb.li/4C46AEAC.7040906@bzed.de
ifeq (,$(findstring hurd,$(DEB_HOST_ARCH_OS)))
	-$(SCONS_ENV) /usr/bin/scons check
endif
endif
	# ensure the test tools are built
	$(SCONS_ENV) python /usr/bin/scons $(SCONSOPTS) $(shell grep test_ debian/gpsd-dbg.install | grep -v '\.py' | awk '{print $$1}')
	touch $@

build-static-stamp: SConstruct.deb_revision
	mkdir static_lib
	find . \
	    -mindepth 1 -maxdepth 1 \
	    -name static_lib \
	    -prune \
	    -o -name debian -prune \
	    -o -exec cp -pr {} static_lib \;
	$(SCONS_ENV) scons -C static_lib $(SCONSOPTS) --clean ;\
	$(SCONS_ENV) scons -C static_lib $(SCONSOPTS) sconsclean || true ;\
	$(SCONS_ENV) scons -C static_lib $(SCONSOPTS) $(SCONSSTATICOPTS) libgps.a
	touch $@

clean: debian/control
	dh_testdir
	dh_testroot
	set -e; \
	    for py in $(PYTHONS); do \
	    	$(SCONS_ENV) python$${py} /usr/bin/scons $(SCONSOPTS) --clean ; \
	    	$(SCONS_ENV) python$${py}-dbg /usr/bin/scons $(SCONSOPTS) --clean ; \
	    done
	$(SCONS_ENV) python /usr/bin/scons $(SCONSOPTS) sconsclean || true
	# revert revision changes in SConstruct
	if [ -f SConstruct.deb_revision ]; then \
	    mv SConstruct.deb_revision SConstruct; \
	fi
	rm -rf \
	    .sconf_temp \
	    .scons-option-cache \
	    .sconsign.dblite \
	    gps/*.pyc \
	    TROUBLESHOOTING \
	    debian/buildinfo.gz \
	    config.log \
	    static_lib \
	    debian/shlibs.local \
	    leapsecond.pyc \
	    $(LIBGPS_DEBIAN_FILE_TARGETS)
	dh_clean

install: install-stamp
install-stamp: build-stamp build-static-stamp $(LIBGPS_DEBIAN_FILE_TARGETS)
	dh_testdir
	dh_testroot
	dh_prep
	set -e ;\
	    for py in $(PYTHONS); do \
	    	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp python$${py} /usr/bin/scons install $(SCONSOPTS) ;\
	    	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp python$${py}-dbg /usr/bin/scons install $(SCONSOPTS) ;\
	    done
	# install static lib
	cp static_lib/libgps.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	cp INSTALL TROUBLESHOOTING
	# install systemd files
	mkdir -p debian/tmp/lib/systemd/system
	cp systemd/* debian/tmp/lib/systemd/system
	# fix various manpages
	for i in cgps.1 gegps.1 lcdgps.1 xgps.1 xgpsspeed.1 gpxlogger.1; do \
	    rm -f debian/tmp/usr/share/man/man1/$$i ;\
	    ln -s gps.1 debian/tmp/usr/share/man/man1/$$i ;\
	done
	rm -f debian/tmp/usr/share/man/man3/libQgpsmm.3
	ln -s libgpsmm.3.gz debian/tmp/usr/share/man/man3/libQgpsmm.3.gz
	# install everything
	dh_install --fail-missing
	# remove rpaths
	find debian -type f -exec file {} \; |\
	    grep ELF |\
	    grep 'dynamically linked' |\
	    sed 's,:.*,,' |\
	    xargs chrpath -d
	touch $@


install-indep: install
install-arch: install

binary: install-stamp
	dh_testdir
	dh_testroot
	dh_installchangelogs  NEWS
	dh_installdocs 
	dh_installman 
	dh_installmenu 
	dh_systemd_enable -pgpsd
	dh_installinit
	dh_systemd_start -pgpsd --restart-after-upgrade
	dh_installexamples 
	chmod 755 debian/$(PACKAGE_PY)/usr/lib/python*/*-packages/gps/gps.py
	dh_python2 -Ngpsd -Ngpsd-clients -Ngpsd-dbg
	dh_python2 -pgpsd-dbg usr/lib/gpsd/debug
	dh_python2 -pgpsd-clients usr/bin
	dh_python2 -pgpsd lib/udev/
	cp $(CURDIR)/gpsd.rules $(CURDIR)/debian/gpsd.udev
	dh_installudev 
	dh_link 
	dh_strip  --dbg-package=$(PACKAGE_GPSDDBG)
	dh_buildinfo -p$(PACKAGE_GPSDDBG)
	dh_compress 
	dh_fixperms  -Xgpsd.hotplug
	dh_lintian
ifeq (,$(DEB_BUILD_OPTIONS))
	dh_makeshlibs -Nlibqgpsmm$(LIBGPS_SONAME) -- -c4
	dh_makeshlibs -plibqgpsmm$(LIBGPS_SONAME) -- -c1
else
	dh_makeshlibs
endif
	dh_shlibdeps 
ifneq (,$(UDEV_BREAKS))
	echo "gpsd:Breaks=udev (<< $(UDEV_BREAKS))" >> $(CURDIR)/debian/gpsd.substvars
endif
	dh_gencontrol 
	dh_installdeb 
	dh_md5sums 
	dh_builddeb 


binary-indep: binary
binary-arch: binary

.PHONY: binary binary-indep binary-arch \
	install install-arch install-indep \
	clean \
	build debian/control

## gpsd 3.16

=== debian/changelog ===
gpsd (3.16-4) unstable; urgency=medium

  * [2405f456] Fix debug symbol handling.
    Debug symbols went missing when upstream switched the strip
    option name.
    Thanks to Andre Naujoks (Closes: #842792)
  * [74c3cd07] Updating debian/control from debian/control.in
  * [b66410da] hadle debian/control creation a bit better
  * [06a9623f] Use gz compression for now.
  * [44376877] Remove obsolete build dependency on hardening-includes.

 -- Bernd Zeimetz <bzed@debian.org>  Fri, 04 Nov 2016 23:35:14 +0100

gpsd (3.16-3) unstable; urgency=medium

  * [aa43cc65] Various patches were applied upstream.
    Take them from there, removing our version.
  * [1444f940] Build with -std=gnu++98. (Closes: #830993)
  * [505d032a] Remove netbase/systemd-sysv dependency.
    Not needed anymore. (Closes: #768100)
  * [b53473f0] Migrate to github.
  * [cb624dcb] Add travis.yml build stuff.
  * [1c3c3463] Updating gbp.conf to ignore travis.yml for debuild.
  * [d870a5c6] Don't rebuild for the static library.

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 24 Sep 2016 14:34:07 +0200

gpsd (3.16-2) unstable; urgency=medium

  * [5001c11a] Do not start gpsd.service by default.
    We use socket based activation only.
    If one needs a running gpsd.service at boot - without being started by
    gpsd.socket - you'll have to configure systemd to start it.
    Too many people have gpsd installed as dependency and do not need yet
    another running process.

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 15 May 2016 15:35:20 +0200

gpsd (3.16-1) unstable; urgency=medium

  * [c3d16637] Merge tag 'upstream/3.16'
    Upstream version 3.16
  * [29863f7a] Snapshot changelog.
  * [e61a749f] refreshing patches.
  * [ddc25e61] Pick some patches from upstream.
    - Fix test_gpsmm building
    - Fix FTBFS on hurd (Closes: #821804)
  * [67d9aca8] Fix check for clock_gettime.
  * [67b39606] Update git-buildpackage config.

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 30 Apr 2016 20:07:13 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Bernd Zeimetz <bzed@debian.org>
-Build-Depends: debhelper (>= 8.1.3~),
+Build-Depends: debhelper (>= 8.1.3~), po-debconf,
  python-all-dev (>= 2.6.6-3),
  python-all-dbg (>= 2.6.6-3),
  xsltproc, docbook-xsl, docbook-xml,
@@ -16,8 +16,7 @@
  scons (>= 2.0.1), chrpath,
  dh-buildinfo,
  pps-tools (>= 0.20120406+g0deb9c7e-2~) [linux-any],
- dh-systemd (>= 1.3),
- dh-python
+ dh-systemd (>= 1.3)
 Standards-Version: 3.9.2
 Homepage: http://www.catb.org/gpsd/
 Vcs-Browser: http://git.recluse.de/?p=debian/pkg-gpsd.git
@@ -49,6 +48,7 @@
 Architecture: any
 Section: debug
 Priority: extra
+Suggests: gpsd-dbgsym
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
  libgps22 (= ${binary:Version}) | gpsd (= ${binary:Version}) | gpsd-clients (= ${binary:Version}) | python-gps (= ${binary:Version})
 Description: Global Positioning System - debugging symbols
@@ -56,14 +56,15 @@
  a host computer, making all data on the location and movements of the
  sensors available to be queried on TCP port 2947.
  .
- This package contains the detached debug symbols for gpsd, gpsd-clients,
- python-gps, and libgps22.
+ This package contains the python debug modules and some test tools
+ to the debug the behaviour of gpsd. Debug symbols are being shipped
+ in the dbgsym package.
 
 Package: gpsd-clients
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
  libgps22 (= ${binary:Version}),
- python-gps, python-gtk2, python-cairo, ${python:Depends}, python
+ python-gps, python-gtk2, python-cairo, ${python:Depends}
 Suggests: gpsd
 Conflicts: gps
 Breaks: ${python:Breaks}
@@ -118,8 +119,7 @@
 Architecture: any
 Section: libdevel
 Depends: libgps22 (= ${binary:Version}), ${misc:Depends}, pkg-config
-Breaks: gpsd (<< 2.34.dfsg-1)
-Replaces: gpsd (<< 2.34.dfsg-1)
+Conflicts: gpsd (<< 2.34.dfsg-1)
 Description: Global Positioning System - development files
  The gpsd service daemon can monitor one or more GPS devices connected to
  a host computer, making all data on the location and movements of the

=== debian/rules ===
--- 
+++ 
@@ -38,7 +38,7 @@
 SCONSOPTS = \
 	prefix=/usr \
 	systemd=yes \
-	strip=no \
+	nostrip=yes \
 	dbus_export=yes \
 	docdir=/usr/share/doc/gpsd \
 	libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
@@ -51,9 +51,6 @@
 else
 	SCONSOPTS += debug=no
 endif
-
-SCONSSTATICOPTS = python=no shared=no
-
 
 #package names
 PACKAGE_GPSD := gpsd
@@ -66,9 +63,9 @@
 PACKAGE_GPSDDBG := gpsd-dbg
 
 
-cflags := $(shell dpkg-buildflags --get CFLAGS)
+cflags := $(shell dpkg-buildflags --get CFLAGS) -std=gnu++98
 cppflags := $(shell dpkg-buildflags --get CPPFLAGS)
-cxxflags := $(shell dpkg-buildflags --get CXXFLAGS)
+cxxflags := $(shell dpkg-buildflags --get CXXFLAGS) -std=gnu++98
 ldflags := $(shell dpkg-buildflags --get LDFLAGS)
 
 SCONS_ENV := set -e ;\
@@ -85,16 +82,12 @@
 	done
 
 debian/control: debian/control.in
-	if grep -q "Package: libgps$(LIBGPS_SONAME)" debian/control; then \
-		touch debian/control ;\
-	else \
-		rm -f $@ ;\
-		sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g' $< > $@ ;\
+		rm -f $@ 
+		sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g' $< > $@ 
 		if [ -d .git ]; then \
 			git add debian/control ;\
 			git commit -m 'Updating debian/control from debian/control.in' debian/control ;\
 		fi ;\
-	fi
 
 SConstruct.deb_revision: SConstruct
 	if [ ! -f $@ ]; then \
@@ -125,16 +118,7 @@
 	touch $@
 
 build-static-stamp: SConstruct.deb_revision
-	mkdir static_lib
-	find . \
-	    -mindepth 1 -maxdepth 1 \
-	    -name static_lib \
-	    -prune \
-	    -o -name debian -prune \
-	    -o -exec cp -pr {} static_lib \;
-	$(SCONS_ENV) scons -C static_lib $(SCONSOPTS) --clean ;\
-	$(SCONS_ENV) scons -C static_lib $(SCONSOPTS) sconsclean || true ;\
-	$(SCONS_ENV) scons -C static_lib $(SCONSOPTS) $(SCONSSTATICOPTS) libgps.a
+	cp libgps_static.a libgps.a
 	touch $@
 
 clean: debian/control
@@ -158,9 +142,9 @@
 	    TROUBLESHOOTING \
 	    debian/buildinfo.gz \
 	    config.log \
-	    static_lib \
 	    debian/shlibs.local \
 	    leapsecond.pyc \
+	    libgps.a \
 	    $(LIBGPS_DEBIAN_FILE_TARGETS)
 	dh_clean
 
@@ -175,7 +159,7 @@
 	    	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp python$${py}-dbg /usr/bin/scons install $(SCONSOPTS) ;\
 	    done
 	# install static lib
-	cp static_lib/libgps.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
+	cp libgps.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
 	cp INSTALL TROUBLESHOOTING
 	# install systemd files
 	mkdir -p debian/tmp/lib/systemd/system
@@ -220,7 +204,7 @@
 	cp $(CURDIR)/gpsd.rules $(CURDIR)/debian/gpsd.udev
 	dh_installudev 
 	dh_link 
-	dh_strip  --dbg-package=$(PACKAGE_GPSDDBG)
+	dh_strip --dbgsym-migration='gpsd-dbg (<< 3.16-4~)'
 	dh_buildinfo -p$(PACKAGE_GPSDDBG)
 	dh_compress 
 	dh_fixperms  -Xgpsd.hotplug

=== debian/watch ===
version=3

http://download-mirror.savannah.gnu.org/releases/gpsd/gpsd-(.*).tar.gz
